jQuery(document).ready(function ($) {
  "use strict";
  var catsp_myScript = function () {
    if ($(".ta-container").length > 0) {
      $(".ta-container").each(function () {
        var catsp_container = $(this),
          catsp_container_id = catsp_container.attr("id"),
          catsp_Wrapper_ID = "#" + catsp_container_id,
          pc_sid = $(catsp_Wrapper_ID).data("sid"), // The Shortcode ID.
          catspCarousel = $("#" + catsp_container_id + " .ta-catsp-carousel"),
          catspAccordion = $("#" + catsp_container_id + " .ta-collapse"),
          catspfilter = $("#" + catsp_container_id + ".catsp-filter-wrapper"),
          ajaxurl = spcatsp.ajaxurl,
          nonce = spcatsp.nonce,
          catspCarouselDir = catspCarousel.attr("dir"),
          catspSwiper,
          catspCarouselData = catspCarousel.data("carousel");
       
        if (catspCarousel.length > 0) {
          var mobile_land = parseInt(
              catspCarouselData.responsive.mobile_landscape
            ),
            tablet_size = parseInt(catspCarouselData.responsive.tablet),
            desktop_size = parseInt(catspCarouselData.responsive.desktop),
            lg_desktop_size = parseInt(catspCarouselData.responsive.lg_desktop);
        }

        // Carousel Init function.
        function catsp_carousel_init() {
          // Carousel ticker mode.
          if (catspCarouselData.mode == "ticker") {
            var item = catspCarousel.find(".swiper-wrapper .swiper-slide").length;
            catspSwiper = catspCarousel.find(".swiper-wrapper").bxSlider({
              mode: "horizontal",
              moveSlides: 1,
              slideMargin: catspCarouselData.spaceBetween,
              infiniteLoop: catspCarouselData.loop,
              slideWidth: catspCarouselData.ticker_width,
              minSlides: catspCarouselData.slidesPerView.mobile,
              maxSlides: catspCarouselData.slidesPerView.lg_desktop,
              speed: catspCarouselData.ticker_speed * item,
              ticker: true,
              tickerHover: catspCarouselData.stop_onHover,
              autoDirection: catspCarouselDir,
            });
          }

          // Carousel Swiper for Standard & Center mode.
          if (
            catspCarouselData.mode == "standard" ||
            catspCarouselData.mode == "center"
          ) {
            if (
              catspCarouselData.effect == "fade" ||
              catspCarouselData.effect == "cube" ||
              catspCarouselData.effect == "flip"
            ) {
              if ($(window).width() > lg_desktop_size) {
                slidePerView = catspCarouselData.slidesPerView.lg_desktop;
              } else if ($(window).width() > desktop_size) {
                slidePerView = catspCarouselData.slidesPerView.desktop;
              } else if ($(window).width() > tablet_size) {
                slidePerView = catspCarouselData.slidesPerView.tablet;
              } else if ($(window).width() > 0) {
                slidePerView = catspCarouselData.slidesPerView.mobile_landscape;
              }
              $(
                catsp_Wrapper_ID +
                  " .ta-catsp-carousel .swiper-wrapper > .ta-catshowcase-pro-item"
              )
                .css("width", 100 / slidePerView + "%")
                .removeClass("swiper-slide");
              var fade_items = $(
                catsp_Wrapper_ID +
                  " .ta-catsp-carousel .swiper-wrapper > .ta-catshowcase-pro-item"
              );
              var style =
                catspCarouselDir == "rtl" ? "marginLeft" : "marginRight";
              for (var i = 0; i < fade_items.length; i += slidePerView) {
                fade_items
                  .slice(i, i + slidePerView)
                  .wrapAll('<div class="swiper-slide"></div>');
                fade_items.eq(i - 1).css(style, 0);
              }
              catspSwiper = new Swiper(
                "#" + catsp_container_id + " .ta-catsp-carousel",
                {
                  speed: catspCarouselData.speed,
                  slidesPerView: 1,
                  spaceBetween: catspCarouselData.spaceBetween,
                  loop:
                    catspCarouselData.slidesRow.lg_desktop > "1" ||
                    catspCarouselData.slidesRow.desktop > "1" ||
                    catspCarouselData.slidesRow.tablet > "1" ||
                    catspCarouselData.slidesRow.mobile_landscape > "1" ||
                    catspCarouselData.slidesRow.mobile > "1"
                      ? false
                      : catspCarouselData.loop,
                  effect: catspCarouselData.effect,
                  slidesPerGroup: catspCarouselData.slideToScroll.mobile,
                  preloadImages: false,
                  observer: true,
                  runCallbacksOnInit: false,
                  initialSlide: 0,
                  slidesPerColumn: catspCarouselData.slidesRow.mobile,
                  slidesPerColumnFill: "row",
                  autoHeight:
                    catspCarouselData.slidesRow.lg_desktop > "1" ||
                    catspCarouselData.slidesRow.desktop > "1" ||
                    catspCarouselData.slidesRow.tablet > "1" ||
                    catspCarouselData.slidesRow.mobile_landscape > "1" ||
                    catspCarouselData.slidesRow.mobile > "1"
                      ? false
                      : catspCarouselData.autoHeight,
                  simulateTouch: catspCarouselData.simulateTouch,
                  allowTouchMove: catspCarouselData.allowTouchMove,
                  mousewheel: catspCarouselData.slider_mouse_wheel,
                  centeredSlides: catspCarouselData.center_mode,
                  lazy: catspCarouselData.lazy,
                  pagination:
                    catspCarouselData.pagination == true
                      ? {
                          el: ".swiper-pagination",
                          clickable: true,
                          dynamicBullets: catspCarouselData.dynamicBullets,
                          renderBullet: function (index, className) {
                            if (catspCarouselData.bullet_types == "number") {
                              return (
                                '<span class="' +
                                className +
                                '">' +
                                (index + 1) +
                                "</span>"
                              );
                            } else {
                              return '<span class="' + className + '"></span>';
                            }
                          },
                        }
                      : false,
                  autoplay: {
                    delay: catspCarouselData.autoplay_speed,
                  },
                  navigation:
                    catspCarouselData.navigation == true
                      ? {
                          nextEl: ".catsp-button-next",
                          prevEl: ".catsp-button-prev",
                        }
                      : false,
                  fadeEffect: {
                    crossFade: true,
                  },
                  ally: {
                    enabled: catspCarouselData.enabled,
                    prevSlideMessage: catspCarouselData.prevSlideMessage,
                    nextSlideMessage: catspCarouselData.nextSlideMessage,
                    firstSlideMessage: catspCarouselData.firstSlideMessage,
                    lastSlideMessage: catspCarouselData.lastSlideMessage,
                    paginationBulletMessage:
                      catspCarouselData.paginationBulletMessage,
                  },
                  keyboard: {
                    enabled: catspCarouselData.keyboard === "true" ? true : false,
                  },
                }
              );
            } else {
              catspSwiper = new Swiper(
                "#" + catsp_container_id + " .ta-catsp-carousel",
                {
                  speed: catspCarouselData.speed,
                  slidesPerView: catspCarouselData.slidesPerView.mobile,
                  spaceBetween: catspCarouselData.spaceBetween,
                  loop:
                    catspCarouselData.slidesRow.lg_desktop > "1" ||
                    catspCarouselData.slidesRow.desktop > "1" ||
                    catspCarouselData.slidesRow.tablet > "1" ||
                    catspCarouselData.slidesRow.mobile_landscape > "1" ||
                    catspCarouselData.slidesRow.mobile > "1"
                      ? false
                      : catspCarouselData.loop,
                  effect: catspCarouselData.effect,
                  slidesPerGroup: catspCarouselData.slideToScroll.mobile,
                  preloadImages: false,
                  observer: true,
                  runCallbacksOnInit: false,
                  initialSlide: 0,
                  slidesPerColumn: catspCarouselData.slidesRow.mobile,
                  slidesPerColumnFill: "row",
                  autoHeight:
                    catspCarouselData.slidesRow.lg_desktop > "1" ||
                    catspCarouselData.slidesRow.desktop > "1" ||
                    catspCarouselData.slidesRow.tablet > "1" ||
                    catspCarouselData.slidesRow.mobile_landscape > "1" ||
                    catspCarouselData.slidesRow.mobile > "1"
                      ? false
                      : catspCarouselData.autoHeight,
                  simulateTouch: catspCarouselData.simulateTouch,
                  allowTouchMove: catspCarouselData.allowTouchMove,
                  mousewheel: catspCarouselData.slider_mouse_wheel,
                  centeredSlides: catspCarouselData.center_mode,
                  lazy: catspCarouselData.lazy,
                  pagination:
                    catspCarouselData.pagination == true
                      ? {
                          el: ".swiper-pagination",
                          clickable: true,
                          dynamicBullets: catspCarouselData.dynamicBullets,
                          renderBullet: function (index, className) {
                            if (catspCarouselData.bullet_types == "number") {
                              return (
                                '<span class="' +
                                className +
                                '">' +
                                (index + 1) +
                                "</span>"
                              );
                            } else {
                              return '<span class="' + className + '"></span>';
                            }
                          },
                        }
                      : false,
                  autoplay: {
                    delay: catspCarouselData.autoplay_speed,
                  },
                  navigation:
                    catspCarouselData.navigation == true
                      ? {
                          nextEl: ".catsp-button-next",
                          prevEl: ".catsp-button-prev",
                        }
                      : false,
                  breakpoints: {
                    [mobile_land]: {
                      slidesPerView:
                        catspCarouselData.slidesPerView.mobile_landscape,
                      slidesPerGroup:
                        catspCarouselData.slideToScroll.mobile_landscape,
                      slidesPerColumn:
                        catspCarouselData.slidesRow.mobile_landscape,
                      navigation:
                        catspCarouselData.navigation_mobile == true
                          ? {
                              nextEl: ".catsp-button-next",
                              prevEl: ".catsp-button-prev",
                            }
                          : false,
                      pagination:
                        catspCarouselData.pagination_mobile == true
                          ? {
                              el: ".swiper-pagination",
                              clickable: true,
                              dynamicBullets: catspCarouselData.dynamicBullets,
                              renderBullet: function (index, className) {
                                if (catspCarouselData.bullet_types == "number") {
                                  return (
                                    '<span class="' +
                                    className +
                                    '">' +
                                    (index + 1) +
                                    "</span>"
                                  );
                                } else {
                                  return (
                                    '<span class="' + className + '"></span>'
                                  );
                                }
                              },
                            }
                          : false,
                    },
                    [tablet_size]: {
                      slidesPerView: catspCarouselData.slidesPerView.tablet,
                      slidesPerGroup: catspCarouselData.slideToScroll.tablet,
                      slidesPerColumn: catspCarouselData.slidesRow.tablet,
                    },
                    [desktop_size]: {
                      slidesPerView: catspCarouselData.slidesPerView.desktop,
                      slidesPerGroup: catspCarouselData.slideToScroll.desktop,
                      slidesPerColumn: catspCarouselData.slidesRow.desktop,
                    },
                    [lg_desktop_size]: {
                      slidesPerView: catspCarouselData.slidesPerView.lg_desktop,
                      slidesPerGroup: catspCarouselData.slideToScroll.lg_desktop,
                      slidesPerColumn: catspCarouselData.slidesRow.lg_desktop,
                    },
                  },
                  fadeEffect: {
                    crossFade: true,
                  },
                  ally: {
                    enabled: catspCarouselData.enabled,
                    prevSlideMessage: catspCarouselData.prevSlideMessage,
                    nextSlideMessage: catspCarouselData.nextSlideMessage,
                    firstSlideMessage: catspCarouselData.firstSlideMessage,
                    lastSlideMessage: catspCarouselData.lastSlideMessage,
                    paginationBulletMessage:
                      catspCarouselData.paginationBulletMessage,
                  },
                  keyboard: {
                    enabled: catspCarouselData.keyboard === "true" ? true : false,
                  },
                }
              );
            }
            if (catspCarouselData.autoplay === false) {
              catspSwiper.autoplay.stop();
            }
            if (catspCarouselData.stop_onHover && catspCarouselData.autoplay) {
              $(catspCarousel).on({
                mouseenter: function () {
                  catspSwiper.autoplay.stop();
                },
                mouseleave: function () {
                  catspSwiper.autoplay.start();
                },
              });
            }
            $(window).on("resize", function () {
              catspSwiper.update();
            });
            $(window).trigger("resize");
          }
        }
        if (catspCarousel.length > 0) {
          catsp_carousel_init();
        }
        $(
          ".ta-overlay.ta-catsp-post,.ta-content-box.ta-catsp-post",
          catsp_Wrapper_ID
        ).on("mouseover", function () {
          $(this)
            .find(".catshowcase__item__content.animated:not(.catsp_hover)")
            .addClass("catsp_hover");
        });

        
        /**
         *  Isotope Filter layout.
         */
        if (catspfilter.length > 0) {
          if (catspfilter.data("grid") == "masonry") {
            var layoutMode = "masonry";
          } else {
            var layoutMode = "fitRows";
          }
          var $grid = $(".grid", catsp_Wrapper_ID).isotope({
            itemSelector: ".item",
            //layoutMode: 'fitRows'
            layoutMode: layoutMode,
          });
          $grid.imagesLoaded().progress(function () {
            $grid.isotope("layout");
          });

          // This function added for catsp-Lazyload.
          function catsp_lazyload() {
            $is_find = $(".ta-catsp-post-thumb-area img").hasClass(
              "catsp-lazyload"
            );
            if ($is_find) {
              $("img.catsp-lazyload")
                .catsp_lazyload({ effect: "fadeIn", effectTime: 2000 })
                .removeClass("catsp-lazyload")
                .addClass("catsp-lazyloaded");
            }
            $grid.isotope("layout");
          }

          // Store filter for each group.
          var filters = {};
          $(".catsp-shuffle-filter .taxonomy-group", catsp_Wrapper_ID).on(
            "change",
            function (event) {
              var $select = $(event.target);
              // get group key
              var filterGroup = $select.attr("data-filter-group");
              // set filter for group
              filters[filterGroup] = event.target.value;
              // combine filters
              var filterValue = concatValues(filters);
              // set filter for Isotope
              $grid.isotope({ filter: filterValue });
              $grid.on("layoutComplete", function () {
                $(window).trigger("scroll");
              });
            }
          );

          $(".catsp-shuffle-filter", catsp_Wrapper_ID).on(
            "click",
            ".catsp-button",
            function (event) {
              var $button = $(event.currentTarget);
              // get group key
              var $taxonomyGroup = $button.parents(".taxonomy-group");
              var filterGroup = $taxonomyGroup.attr("data-filter-group");
              // taxonomy = $taxonomyGroup.attr('data-filter-group');
              // set filter for group
              filters[filterGroup] = $button.attr("data-filter");
              //  term_id = $button.attr('data-termid');
              // combine filters
              var filterValue = concatValues(filters);
              // set filter for Isotope
              $grid.isotope({ filter: filterValue });
              $grid.on("layoutComplete", function () {
                $(window).trigger("scroll");
              });
            }
          );
          // Change is-active class on buttons.
          $(".taxonomy-group", catsp_Wrapper_ID).each(function (
            i,
            taxonomyGroup
          ) {
            var $taxonomyGroup = $(taxonomyGroup);
            var $find_active_button = $taxonomyGroup.find(".is-active");
            if ($find_active_button.length == 0) {
              $taxonomyGroup
                .find("button:nth-child(1)")
                .addClass("is-active")
                .click();
            }
            $taxonomyGroup.on("click", "button", function (event) {
              $taxonomyGroup.find(".is-active").removeClass("is-active");
              var $button = $(event.currentTarget);
              $button.addClass("is-active");
            });
          });
          // Flatten object by concatenation values.
          function concatValues(obj) {
            var value = "";
            for (var prop in obj) {
              value += obj[prop];
            }
            return value;
          }
        }

        function catsp_item_same_height() {
          var maxHeight = 0;
          $(catsp_Wrapper_ID + ".catsp_same_height .item").each(function () {
            if ($(this).find(".ta-catsp-post").height() > maxHeight) {
              maxHeight = $(this).find(".ta-catsp-post").height();
            }
          });
          $(catsp_Wrapper_ID + ".catsp_same_height .ta-catsp-post").height(maxHeight);
        }
        if (
          $(catsp_Wrapper_ID + ".catsp_same_height").hasClass("catsp-filter-wrapper")
        ) {
          catsp_item_same_height();
        }

        // Ajax Action for Live filter.
        var keyword = "",
          orderby = "",
          taxonomy = "",
          order = "",
          term_id = "",
          page = "",
          spsp_lang = $(catsp_Wrapper_ID).data("lang");
          var author_id = "",
          custom_field_key = "",
          custom_field_value = "",
          catsp_hash_url = Array(),
          catsp_last_filter = "",
          custom_fields_array = Array(),
          is_pagination_url_change = true;
        function catsp_ajax_action(selected_term_list = null) {
          jQuery.ajax({
            url: ajaxurl,
            type: "POST",
            data: {
              action: "catsp_product_order",
              id: pc_sid,
              lang: spsp_lang,
              order: order,
              keyword: keyword,
              orderby: orderby,
              taxonomy: taxonomy,
              term_id: term_id,
              author_id: author_id,
              nonce: nonce,
              term_list: selected_term_list,
              custom_fields_array: custom_fields_array,
            },
            success: function (data) {
              var $data = $(data);
              var $newElements = $data;

              if ($(catsp_Wrapper_ID).hasClass("catsp-masonry")) {
                var $product_wrapper = $(".ta-row", catsp_Wrapper_ID);
                $product_wrapper.masonry("destroy");
                $product_wrapper.html($newElements).imagesLoaded(function () {
                  $product_wrapper.masonry();
                });
              } else if ($(catsp_Wrapper_ID).hasClass("catsp-filter-wrapper")) {
                $(
                  ".ta-row, .catsp-timeline-grid, .ta-collapse, .table-responsive tbody",
                  catsp_Wrapper_ID
                ).html($newElements);
                $grid
                  .append($newElements)
                  .isotope("appended", $newElements)
                  .imagesLoaded(function () {
                    $grid.isotope("layout");
                  });
                catsp_item_same_height();
              } else if (catspCarousel.length > 0) {
                if (catspCarouselData.mode == "ticker") {
                  catspSwiper.destroySlider();
                  $(".swiper-wrapper", catsp_Wrapper_ID).html($newElements);
                  catsp_carousel_init();
                  catspSwiper.reloadSlider();
                } else {
                  catspSwiper.destroy(true, true);
                  $(".swiper-wrapper", catsp_Wrapper_ID).html($newElements);
                  catsp_carousel_init();
                }
              } else {
                var $newElements = $data.css({
                  opacity: 0,
                });
                $(
                  ".ta-row, .catsp-timeline-grid, .ta-collapse, .table-responsive tbody",
                  catsp_Wrapper_ID
                ).html($newElements);
                if (catspAccordion.length > 0) {
                  catspAccordion.accordion("refresh");
                  if (accordion_mode === "multi-open") {
                    catspAccordion
                      .find(".catsp-collapse-header")
                      .next()
                      .slideDown();
                    catspAccordion
                      .find(".catsp-collapse-header .fa")
                      .removeClass("fa-plus")
                      .addClass("fa-minus");
                  }
                }
                var $newElements = $data.css({
                  opacity: 1,
                });
              }
              catsp_lazyload();
            },
          });
        }

        // Live filter button reset on ajax call.
        function catsp_live_filter_reset(selected_term_list = null) {
          jQuery.ajax({
            url: ajaxurl,
            type: "POST",
            data: {
              action: "catsp_live_filter_reset",
              id: pc_sid,
              order: order,
              lang: spsp_lang,
              keyword: keyword,
              orderby: orderby,
              taxonomy: taxonomy,
              term_id: term_id,
              author_id: author_id,
              nonce: nonce,
              term_list: selected_term_list,
              last_filter: catsp_last_filter,
              custom_fields_array: custom_fields_array,
            },
            success: function (data) {
              var $data = $(data);
              var $newElements = $data.animate({
                opacity: 0.5,
              });
              $(".catsp-filter-bar", catsp_Wrapper_ID).html($newElements);
              custom_field_filter_slider();
              $newElements.animate({
                opacity: 1,
              });
            },
          });
        }
        // Update Hash url array.
        function catsp_hash_update_arr(catsp_filter_keyword, filter_arr, key) {
          if (catsp_hash_url.length > 0) {
            catsp_hash_url.forEach(function (row) {
              if ($.inArray(catsp_filter_keyword, row.catsp_filter_keyword)) {
                row[key] = catsp_filter_keyword;
              } else {
                catsp_hash_url.push(filter_arr);
              }
            });
          } else {
            catsp_hash_url.push(filter_arr);
          }
          return catsp_hash_url;
        }
        // On normal pagination go to current shortcode.
        var url_hash = window.location.search;
        if (url_hash.indexOf("paged") >= 0) {
          var s_id = /paged(\d+)/.exec(url_hash)[1];
          var spscurrent_id = document.getElementById("catsp_wrapper-" + s_id);
          spscurrent_id.scrollIntoView();
        }
        // Update url.
        var selected_term_list = Array();
        function catsp_update_url() {
          var p_search = window.location.search;
          if (p_search.indexOf("page_id") >= 0) {
            var catsp_page = /page_id\=(\d+)/.exec(p_search)[1];
            var catsp_url = "?page_id=" + catsp_page + "&";
          } else {
            var catsp_url = "&";
          }
          if (catsp_hash_url.length > 0) {
            $.map(catsp_hash_url, function (value, index) {
              $.map(value, function (value2, index2) {
                if (
                  value2 == "all" ||
                  value2 == "none" ||
                  value2 == "" ||
                  value2 == "page"
                ) {
                  catsp_url += "";
                } else {
                  catsp_url += "catsp_" + index2 + "=" + value2 + "&";
                }
              });
            });
          }
          if (selected_term_list.length > 0) {
            var term_total_length = selected_term_list.length;
            $.map(selected_term_list, function (value, index) {
              if (value.term_id == "all" || value.term_id == "") {
                catsp_url += "";
              } else {
                if (index == term_total_length - 1) {
                  catsp_url += "tx_" + value.taxonomy + "=" + value.term_id + "";
                } else {
                  catsp_url += "tx_" + value.taxonomy + "=" + value.term_id + "&";
                }
              }
            });
          }
          if (custom_fields_array.length > 0) {
            var meta_field_total_length = custom_fields_array.length;
            $.map(custom_fields_array, function (value, index) {
              //  if (index == meta_field_total_length - 1) {
              catsp_url +=
                "cf" +
                value.custom_field_key +
                "=" +
                value.custom_field_value +
                "&";
              // }
            });
          }
          if (catsp_hash_url.length < 0 || selected_term_list.length < 0) {
            catsp_url = "";
          }
          if (catsp_url.length > 1) {
            var slf = "";
            if (catsp_last_filter.length > 0) {
              var slf = "&slf=" + catsp_last_filter;
            }

            catsp_url = "?sps=" + pc_sid + slf + catsp_url;
            history.pushState(null, null, encodeURI(catsp_url));
          } else {
            var uri = window.location.toString();
            if (uri.indexOf("?") > 0) {
              var clean_uri = uri.substring(0, uri.indexOf("?"));
              window.history.replaceState({}, document.title, clean_uri);
            }
          }
        }

        function custom_field_filter_slider() {
          $(catsp_Wrapper_ID + " .catsp-custom-field-filter-slider").each(
            function () {
              var _that = $(this);
              var _input = _that.find(".catsp-input");
              var custom_field_key = _input.attr("name");
              var _min = _input.data("min");
              var _crmin = _input.data("crmin");
              var _crmax = _input.data("crmax");
              var _max = _input.data("max");
              _that.find(".catsp-slider").slider({
                range: true,
                min: _crmin,
                max: _crmax,
                values: [_min, _max],
                slide: function (event, ui) {
                  _input.val(ui.values[0] + " - " + ui.values[1]);
                },
                stop: function (event, ui) {
                  _input.data("max", ui.values[1]);

                  custom_field_value = ui.values[0] + " " + ui.values[1];
                  custom_fields_array.push({
                    custom_field_key,
                    custom_field_value,
                  });
                  custom_fields_array.map(function (person) {
                    if (person.custom_field_key === custom_field_key) {
                      person.custom_field_value = custom_field_value;
                    }
                  });
                  custom_fields_array = $.grep(
                    custom_fields_array,
                    function (e, i) {
                      return e.custom_field_value.length;
                    }
                  );
                  custom_fields_array = custom_fields_array
                    .map(JSON.stringify)
                    .reverse() // convert to JSON string the array content, then reverse it (to check from end to beginning)
                    .filter(function (item, index, arr) {
                      return arr.indexOf(item, index + 1) === -1;
                    }) // check if there is any occurrence of the item in whole array
                    .reverse()
                    .map(JSON.parse);
                  catsp_update_url();
                  catsp_last_filter = custom_field_key;
                  catsp_ajax_action(selected_term_list);
                  catsp_live_filter_reset(selected_term_list);
                },
              });
            }
          );
        }
        custom_field_filter_slider();
        // Ajax post search.
        $("input.catsp-search-field", catsp_Wrapper_ID).on("keyup", function () {
          var that = $(this);
          keyword = that.val();
          catsp_last_filter = "keyword";
          var catsp_search_arr = { keyword, keyword };
          catsp_live_filter_reset(selected_term_list);
          catsp_hash_update_arr(keyword, catsp_search_arr, "keyword");
          catsp_update_url();
          catsp_ajax_action(selected_term_list);
          catsp_pagination_action();
          is_pagination_url_change = false;
          catsp_hash_update_arr("page", { page: "" }, "page");
          catsp_update_url();
        });

        // Post order by.
        $(".catsp-order-by", catsp_Wrapper_ID).on("change", function () {
          var that;
          $(this)
            .find("option:selected, input:radio:checked")
            .each(function () {
              that = $(this);
              orderby = that.val();
            });
          var orerbyarr = { orderby, orderby };
          catsp_hash_update_arr(orderby, orerbyarr, "orderby");
          catsp_update_url();
          catsp_ajax_action();
          catsp_pagination_action();
          catsp_hash_update_arr("page", { page: "" }, "page");
          catsp_update_url();
        });

        function catsp_filter_push(myarr, item) {
          var found = false;
          var i = 0;
          while (i < myarr.length) {
            if (myarr[i] === item) {
              // Do the logic (delete or replace)
              found = true;
              break;
            }
            i++;
          }
          // Add the item
          if (!found) myarr.push(item);
          return myarr;
        }

        // Pre Filter Init.
        var tax_list = Array();
        $(".catsp-filter-by", catsp_Wrapper_ID)
          .find("option:selected, input:radio:checked")
          .each(function () {
            term_id = $(this).val();
            taxonomy = $(this).data("taxonomy");
            var selected_tax_length = selected_term_list.length;
            if (selected_tax_length > 0) {
              var selected_tax =
                selected_term_list[selected_tax_length - 1]["taxonomy"];
              selected_term_list.map(function (person) {
                if (person.taxonomy === taxonomy) {
                  person.term_id = term_id;
                }
              });
              // if ($.inArray(taxonomy, tax_list) == -1) {
              selected_term_list.push({
                taxonomy,
                term_id,
              });
              //  }
              if (
                selected_term_list[selected_tax_length - 1]["term_id"] ==
                  "all" &&
                selected_tax === taxonomy
              ) {
                tax_list = tax_list.filter(function (val) {
                  return val !== taxonomy;
                });
              } else {
                tax_list = catsp_filter_push(tax_list, taxonomy);
              }
              selected_term_list = $.grep(selected_term_list, function (e, i) {
                return e.term_id != "all";
              });
            } else {
              selected_term_list.push({
                taxonomy,
                term_id,
              });
              selected_term_list = $.grep(selected_term_list, function (e, i) {
                return e.term_id != "all";
              });
              tax_list = Array(taxonomy);
            }
          });
        $(".catsp-author-filter", catsp_Wrapper_ID)
          .find("option:selected, input:radio:checked")
          .each(function () {
            that = $(this);
            author_id = that.val();
          });
        $(".catsp-order", catsp_Wrapper_ID)
          .find("option:selected, input:radio:checked")
          .each(function () {
            that = $(this);
            order = $(this).val();
          });
        $(".catsp-order-by", catsp_Wrapper_ID)
          .find("option:selected, input:radio:checked")
          .each(function () {
            that = $(this);
            orderby = that.val();
          });
        $("input.catsp-search-field", catsp_Wrapper_ID).each(function () {
          var that = $(this);
          keyword = that.val();
        });
        $(".catsp-filter-by-checkbox", catsp_Wrapper_ID).each(function () {
          var current_tax = $(this).data("taxonomy");
          var term_ids = "";
          $(this)
            .find("input[name='" + current_tax + "']:checkbox:checked")
            .each(function () {
              term_ids += $(this).val() + ",";
              taxonomy = $(this).data("taxonomy");
            });
          term_id = term_ids.replace(/,(?=\s*$)/, "");
          selected_term_list.map(function (person) {
            if (person.taxonomy === current_tax) {
              person.term_id = term_id;
            }
          });
          selected_term_list.push({
            taxonomy,
            term_id,
          });
        });
        selected_term_list = $.grep(selected_term_list, function (e, i) {
          return e.term_id.length;
        });
        // Custom field filter.
        $(".catsp-custom-field-filter", catsp_Wrapper_ID).each(function () {
          $(this)
            .find("option:selected, input:radio:checked")
            .each(function () {
              custom_field_key = $(this).attr("name");
              custom_field_value = $(this).val();
              custom_fields_array.map(function (person) {
                if (person.custom_field_key === custom_field_key) {
                  person.custom_field_value = custom_field_value;
                }
              });
              custom_fields_array.push({
                custom_field_key,
                custom_field_value,
              });
            });
        });
        selected_term_list = selected_term_list
          .map(JSON.stringify)
          .reverse() // convert to JSON string the array content, then reverse it (to check from end to beginning)
          .filter(function (item, index, arr) {
            return arr.indexOf(item, index + 1) === -1;
          }) // check if there is any occurence of the item in whole array
          .reverse()
          .map(JSON.parse);
        // Filter by checkbox.
        $(catsp_Wrapper_ID).on("change", ".catsp-filter-by-checkbox", function (e) {
          e.stopPropagation();
          e.preventDefault();
          $(".catsp-filter-by-checkbox", catsp_Wrapper_ID).each(function () {
            var current_tax = $(this).data("taxonomy");
            var term_ids = "";
            $(this)
              .find("input[name='" + current_tax + "']:checkbox:checked")
              .each(function () {
                term_ids += $(this).val() + ",";
                taxonomy = $(this).data("taxonomy");
              });
            term_id = term_ids.replace(/,(?=\s*$)/, "");
            selected_term_list.map(function (person) {
              if (person.taxonomy === current_tax) {
                person.term_id = term_id;
              }
            });
            selected_term_list.push({
              taxonomy,
              term_id,
            });
          });
          selected_term_list = $.grep(selected_term_list, function (e, i) {
            return e.term_id.length;
          });
          selected_term_list = selected_term_list
            .map(JSON.stringify)
            .reverse() // convert to JSON string the array content, then reverse it (to check from end to beginning)
            .filter(function (item, index, arr) {
              return arr.indexOf(item, index + 1) === -1;
            }) // check if there is any occurence of the item in whole array
            .reverse()
            .map(JSON.parse);
          var term_ids = "";
          $(this)
            .find("input:checkbox:checked")
            .each(function () {
              term_ids += $(this).val() + ",";
              taxonomy = $(this).data("taxonomy");
            });
          taxonomy = $(this).data("taxonomy");
          term_id = term_ids.replace(/,(?=\s*$)/, "");
          if (term_id.length > 0) {
            catsp_last_filter = taxonomy;
          } else {
            catsp_last_filter = catsp_last_filter;
          }
          catsp_hash_update_arr("page", { page: "" }, "page");
          catsp_update_url();
          catsp_live_filter_reset(selected_term_list);
          catsp_ajax_action(selected_term_list);
          catsp_pagination_action(selected_term_list);
        });

        // Filter by custom field.
        $(catsp_Wrapper_ID).on(
          "change",
          ".catsp-custom-field-filter",
          function (e) {
            e.stopPropagation();
            e.preventDefault();
            $(".catsp-custom-field-filter", catsp_Wrapper_ID).each(function () {
              $(this)
                .find("option:selected, input:radio:checked")
                .each(function () {
                  custom_field_key = $(this).attr("name");
                  custom_field_value = $(this).val();
                  custom_fields_array.map(function (person) {
                    if (person.custom_field_key === custom_field_key) {
                      person.custom_field_value = custom_field_value;
                    }
                  });
                  custom_fields_array.push({
                    custom_field_key,
                    custom_field_value,
                  });
                });
            });
            catsp_last_filter = $(this)
              .find("option:selected, input:radio:checked")
              .attr("name");
            custom_fields_array = $.grep(custom_fields_array, function (e, i) {
              return e.custom_field_value != "all";
            });
            custom_fields_array = custom_fields_array
              .map(JSON.stringify)
              .reverse() // convert to JSON string the array content, then reverse it (to check from end to beginning)
              .filter(function (item, index, arr) {
                return arr.indexOf(item, index + 1) === -1;
              }) // check if there is any occurence of the item in whole array
              .reverse()
              .map(JSON.parse);
            catsp_ajax_action(selected_term_list);
            catsp_pagination_action(selected_term_list);
            catsp_live_filter_reset(selected_term_list);
            catsp_update_url();
          }
        );
        // Filter by checkbox custom field.
        $(catsp_Wrapper_ID).on(
          "change",
          ".catsp-custom-field-filter-checkbox",
          function (e) {
            e.stopPropagation();
            e.preventDefault();
            $(".catsp-custom-field-filter-checkbox", catsp_Wrapper_ID).each(
              function () {
                var custom_field_key = $(this)
                  .find("input:checkbox")
                  .attr("name");
                var custom_field_value = "";
                $(this)
                  .find(
                    "input[name='" + custom_field_key + "']:checkbox:checked"
                  )
                  .each(function () {
                    custom_field_key = $(this).attr("name");
                    custom_field_value += $(this).val() + ",";
                  });
                custom_field_value = custom_field_value.replace(
                  /,(?=\s*$)/,
                  ""
                );
                custom_fields_array.push({
                  custom_field_key,
                  custom_field_value,
                });
                custom_fields_array.map(function (person) {
                  if (person.custom_field_key === custom_field_key) {
                    person.custom_field_value = custom_field_value;
                  }
                });
                custom_fields_array = $.grep(
                  custom_fields_array,
                  function (e, i) {
                    return e.custom_field_value.length;
                  }
                );
              }
            );
            catsp_last_filter = $(this)
              .find("input:checkbox:checked")
              .attr("name");
            custom_fields_array = custom_fields_array
              .map(JSON.stringify)
              .reverse() // convert to JSON string the array content, then reverse it (to check from end to beginning)
              .filter(function (item, index, arr) {
                return arr.indexOf(item, index + 1) === -1;
              }) // check if there is any occurrence of the item in whole array
              .reverse()
              .map(JSON.parse);
            catsp_ajax_action(selected_term_list);
            catsp_pagination_action(selected_term_list);
            catsp_live_filter_reset(selected_term_list);
            catsp_update_url();
          }
        );
        // Filter by taxonomy.
        $(catsp_Wrapper_ID).on("change", ".catsp-filter-by", function (e) {
          e.stopPropagation();
          e.preventDefault();
          $(this)
            .find("option:selected, input:radio:checked")
            .each(function () {
              term_id = $(this).val();
              taxonomy = $(this).data("taxonomy");
              var selected_tax_length = selected_term_list.length;
              if (selected_tax_length > 0) {
                var selected_tax =
                  selected_term_list[selected_tax_length - 1]["taxonomy"];
                selected_term_list.map(function (person) {
                  if (person.taxonomy === taxonomy) {
                    person.term_id = term_id;
                  }
                });
                // if ($.inArray(taxonomy, tax_list) == -1) {
                selected_term_list.push({
                  taxonomy,
                  term_id,
                });
                //  }
                if (
                  selected_term_list[selected_tax_length - 1]["term_id"] ==
                    "all" &&
                  selected_tax === taxonomy
                ) {
                  tax_list = tax_list.filter(function (val) {
                    return val !== taxonomy;
                  });
                } else {
                  tax_list = catsp_filter_push(tax_list, taxonomy);
                }
                selected_term_list = $.grep(
                  selected_term_list,
                  function (e, i) {
                    return e.term_id != "all";
                  }
                );
              } else {
                selected_term_list.push({
                  taxonomy,
                  term_id,
                });
                tax_list = Array(taxonomy);
              }
            });
          if (term_id == "all") {
            catsp_last_filter = catsp_last_filter;
          } else {
            catsp_last_filter = taxonomy;
          }
          selected_term_list = selected_term_list
            .map(JSON.stringify)
            .reverse()
            .filter(function (item, index, selected_term_list) {
              return selected_term_list.indexOf(item, index + 1) === -1;
            })
            .reverse()
            .map(JSON.parse);
          catsp_hash_update_arr("page", { page: "" }, "page");
          catsp_update_url();
          // if ($('.catsp-filter-by', catsp_Wrapper_ID).length > 1) {
          catsp_live_filter_reset(selected_term_list);
          //}
          catsp_ajax_action(selected_term_list);
          catsp_pagination_action(selected_term_list);
        });
        // Author filter.
        $(catsp_Wrapper_ID).on("change", ".catsp-author-filter", function (e) {
          var that;
          $(this)
            .find("option:selected, input:radio:checked")
            .each(function () {
              that = $(this);
              author_id = that.val();
            });
          var author_arr = { author_id, author_id };
          if (author_id == "all") {
            catsp_last_filter = catsp_last_filter;
          } else {
            catsp_last_filter = "author_id";
          }
          catsp_hash_update_arr(author_id, author_arr, "author_id");
          catsp_update_url();
          catsp_live_filter_reset(selected_term_list);
          catsp_ajax_action();
          catsp_pagination_action();
        });

        // Post order asc/dsc.
        $(catsp_Wrapper_ID).on("change", ".catsp-order", function (e) {
          var that;
          $(this)
            .find("option:selected, input:radio:checked")
            .each(function () {
              that = $(this);
              order = $(this).val();
            });
          var order_arr = { order, order };
          catsp_hash_update_arr(order, order_arr, "order");
          catsp_update_url();
          catsp_ajax_action();
          catsp_pagination_action();
          catsp_hash_update_arr("page", { page: "" }, "page");
          catsp_update_url();
        });
        /**
         * Grid masonry.
         */
        if ($(catsp_Wrapper_ID).hasClass("catsp-masonry")) {
          var $product_wrapper = $(".ta-row", catsp_Wrapper_ID);
          $product_wrapper.imagesLoaded(function () {
            $product_wrapper.masonry(/* {
                itemSelector: 'div[class*=ta-col-]',
                //fitWidth: true,
                percentPosition: true
              } */);
          });
        }

        /**
         * The Pagination effects.
         *
         * The effects for pagination to work for both mobile and other screens.
         */
        var Pagination_Type = $(catsp_Wrapper_ID).data("pagination");
        if ($(window).width() <= 480) {
          var Pagination_Type = $(catsp_Wrapper_ID).data("pagination_mobile");
        }
        // Ajax number pagination
        if (Pagination_Type == "ajax_pagination") {
          $(catsp_Wrapper_ID).on("click", ".catsp-post-pagination a", function (e) {
            e.preventDefault();
            var that = $(this);
            var totalPage = $(
                ".catsp-post-pagination.catsp-on-desktop a:not(.catsp_next, .catsp_prev)",
                catsp_Wrapper_ID
              ).length,
              currentPage = parseInt(
                $(
                  ".catsp-post-pagination.catsp-on-desktop .active:not(.catsp_next, .catsp_prev)",
                  catsp_Wrapper_ID
                ).data("page")
              );
            if ($(window).width() <= 480) {
              var totalPage = $(
                  ".catsp-post-pagination.catsp-on-mobile a:not(.catsp_next, .catsp_prev)",
                  catsp_Wrapper_ID
                ).length,
                currentPage = parseInt(
                  $(
                    ".catsp-post-pagination.catsp-on-mobile .active:not(.catsp_next, .catsp_prev)",
                    catsp_Wrapper_ID
                  ).data("page")
                );
            }
            page = parseInt(that.data("page"));
            if (that.hasClass("catsp_next")) {
              if (totalPage > currentPage) {
                var page = currentPage + 1;
              } else {
                return;
              }
            }
            if (that.hasClass("catsp_prev")) {
              if (currentPage > 1) {
                var page = currentPage - 1;
              } else {
                return;
              }
            }
            var catsp_paged = { page, page };
            $.ajax({
              url: ajaxurl,
              type: "post",
              data: {
                page: page,
                id: pc_sid,
                action: "post_grid_ajax",
                order: order,
                lang: spsp_lang,
                keyword: keyword,
                orderby: orderby,
                taxonomy: taxonomy,
                term_id: term_id,
                author_id: author_id,
                term_list: selected_term_list,
                custom_fields_array: custom_fields_array,
                nonce: nonce,
              },
              error: function (response) {
              },
              success: function (response) {
                var $data = $(response);
                var $newElements = $data;
                if ($(catsp_Wrapper_ID).hasClass("catsp-masonry")) {
                  var $product_wrapper = $(".ta-row", catsp_Wrapper_ID);
                  $product_wrapper.masonry("destroy");
                  $product_wrapper.html($newElements).imagesLoaded(function () {
                    $product_wrapper.masonry();
                  });
                } else if ($(catsp_Wrapper_ID).hasClass("catsp-filter-wrapper")) {
                  $grid
                    .html($newElements)
                    .isotope("appended", $newElements)
                    .imagesLoaded(function () {
                      $grid.isotope("layout");
                    });
                  catsp_item_same_height();
                } else {
                  $(
                    ".ta-row, .catsp-timeline-grid, .ta-collapse, .table-responsive tbody",
                    catsp_Wrapper_ID
                  ).html($newElements);
                  if (catspAccordion.length > 0) {
                    catspAccordion.accordion("refresh");
                    if (accordion_mode === "multi-open") {
                      catspAccordion
                        .find(".catsp-collapse-header")
                        .next()
                        .slideDown();
                      catspAccordion
                        .find(".catsp-collapse-header .fa")
                        .removeClass("fa-plus")
                        .addClass("fa-minus");
                    }
                  }
                  var $newElements = $data.css({
                    opacity: 1,
                  });
                }
                $(".page-numbers", catsp_Wrapper_ID).removeClass("active");
                $(".page-numbers", catsp_Wrapper_ID).each(function () {
                  // if (parseInt($('.catsp-post-pagination a').data('page')) === page) {
                  $(
                    ".catsp-post-pagination a[data-page=" + page + "]",
                    catsp_Wrapper_ID
                  ).addClass("active");
                  // }
                });
                $(".catsp_next", catsp_Wrapper_ID).removeClass("active");
                $(".catsp_prev", catsp_Wrapper_ID).removeClass("active");
                $(".catsp-post-pagination a.active", catsp_Wrapper_ID).each(
                  function () {
                    if (parseInt($(this).data("page")) === totalPage) {
                      $(".catsp_next", catsp_Wrapper_ID).addClass("active");
                    }
                    if (parseInt($(this).data("page")) === 1) {
                      $(".catsp_prev", catsp_Wrapper_ID).addClass("active");
                    }
                  }
                );
                if (catspAccordion.length > 0) {
                  catspAccordion.accordion("refresh");
                  if (accordion_mode === "multi-open") {
                    catspAccordion
                      .find(".catsp-collapse-header")
                      .next()
                      .slideDown();
                    catspAccordion
                      .find(".catsp-collapse-header .fa")
                      .removeClass("fa-plus")
                      .addClass("fa-minus");
                  }
                }
                $newElements.animate({
                  opacity: 1,
                });
                catsp_lazyload();
                // Ajax Number pagination go to current shortcode top.
                var url_hash = window.location.search;
                if (url_hash.indexOf("catsp_page") >= 0) {
                  var current_screen_id =
                    document.querySelector(catsp_Wrapper_ID);
                  current_screen_id.scrollIntoView();
                }
              },
            });
            catsp_hash_update_arr(page, catsp_paged, "page");
            catsp_update_url();
          });
        }

        /**
         * Ajax load on click and Infinite scroll.
         */
        if (
          Pagination_Type == "infinite_scroll" ||
          Pagination_Type == "ajax_load_more"
        ) {
          $(catsp_Wrapper_ID).each(function () {
            var EndingMessage = $(this)
              .find(".ta-catsp-pagination-data")
              .data("endingtext");
            var LoadMoreText = $(this)
              .find(".ta-catsp-pagination-data")
              .data("loadmoretext");
            if (
              !$(this)
                .find(".catsp-load-more")
                .hasClass("catsp-load-more-initialize")
            ) {
              if ($(".catsp-post-pagination a", catsp_Wrapper_ID).length) {
                $(".catsp-post-pagination", catsp_Wrapper_ID)
                  .eq(0)
                  .before(
                    '<div class="catsp-load-more"><button catsp-processing="0">' +
                      LoadMoreText +
                      "</button></div>"
                  );
              }
              if (Pagination_Type == "infinite_scroll") {
                $(".catsp-load-more", catsp_Wrapper_ID).addClass("catsp-hide");
              }
              $(".catsp-post-pagination", catsp_Wrapper_ID).addClass("catsp-hide");
              $(".ta-row div[class*=ta-col-]", catsp_Wrapper_ID).addClass(
                "catsp-added"
              );
              $(this)
                .find(".catsp-load-more")
                .addClass("catsp-load-more-initialize");
              $(this).on("click", ".catsp-load-more button", function (e) {
                e.preventDefault();
                if (
                  $(
                    ".catsp-post-pagination a.active:not(.catsp_next, .catsp_prev)",
                    catsp_Wrapper_ID
                  ).length
                ) {
                  $(".catsp-load-more button").attr("catsp-processing", 1);
                  var current_page = parseInt(
                    $(
                      ".catsp-post-pagination a.active:not(.catsp_next, .catsp_prev)",
                      catsp_Wrapper_ID
                    ).data("page")
                  );
                  current_page = current_page + 1;
                  $(".catsp-load-more", catsp_Wrapper_ID).hide();
                  $(".catsp-post-pagination", catsp_Wrapper_ID)
                    .eq(0)
                    .before(
                      '<div class="catsp-infinite-scroll-loader"><svg width="44" height="44" viewBox="0 0 44 44" xmlns="http://www.w3.org/2000/svg" stroke="#444"><g fill="none" fill-rule="evenodd" stroke-width="2"><circle cx="22" cy="22" r="1"><animate attributeName="r" begin="0s" dur="1.8s" values="1; 20" calcMode="spline" keyTimes="0; 1" keySplines="0.165, 0.84, 0.44, 1" repeatCount="indefinite" /> <animate attributeName="stroke-opacity" begin="0s" dur="1.8s" values="1; 0" calcMode="spline" keyTimes="0; 1" keySplines="0.3, 0.61, 0.355, 1" repeatCount="indefinite" /> </circle> <circle cx="22" cy="22" r="1"> <animate attributeName="r" begin="-0.9s" dur="1.8s" values="1; 20" calcMode="spline" keyTimes="0; 1" keySplines="0.165, 0.84, 0.44, 1" repeatCount="indefinite" /> <animate attributeName="stroke-opacity" begin="-0.9s" dur="1.8s" values="1; 0" calcMode="spline" keyTimes="0; 1" keySplines="0.3, 0.61, 0.355, 1" repeatCount="indefinite"/></circle></g></svg></div>'
                    );
                  var totalPage = $(
                    ".catsp-post-pagination.catsp-on-desktop.infinite_scroll a:not(.catsp_next, .catsp_prev), .catsp-post-pagination.catsp-on-desktop.ajax_load_more a:not(.catsp_next, .catsp_prev)",
                    catsp_Wrapper_ID
                  ).length;
                  if ($(window).width() <= 480) {
                    var totalPage = $(
                      ".catsp-post-pagination.catsp-on-mobile.infinite_scroll a:not(.catsp_next, .catsp_prev), .catsp-post-pagination.ajax_load_more.catsp-on-mobile  a:not(.catsp_next, .catsp_prev)",
                      catsp_Wrapper_ID
                    ).length;
                  }
                  page = current_page;
                  $.ajax({
                    url: ajaxurl,
                    type: "post",
                    data: {
                      page: page,
                      id: pc_sid,
                      action: "post_grid_ajax",
                      order: order,
                      lang: spsp_lang,
                      keyword: keyword,
                      orderby: orderby,
                      taxonomy: taxonomy,
                      term_id: term_id,
                      author_id: author_id,
                      term_list: selected_term_list,
                      custom_fields_array: custom_fields_array,
                      nonce: nonce,
                    },
                    error: function (response) {
                    },
                    success: function (response) {
                      var $data = $(response);
                      var $newElements = $data;
                      if ($(catsp_Wrapper_ID).hasClass("catsp-masonry")) {
                        var $product_wrapper = $(".ta-row", catsp_Wrapper_ID);
                        $product_wrapper.masonry("destroy");
                        $product_wrapper
                          .append($newElements)
                          .imagesLoaded(function () {
                            $product_wrapper.masonry();
                          });
                      } else if (
                        $(catsp_Wrapper_ID).hasClass("catsp-filter-wrapper")
                      ) {
                        $grid
                          .append($newElements)
                          .isotope("appended", $newElements)
                          .imagesLoaded(function () {
                            $grid.isotope("layout");
                          });
                        catsp_item_same_height();
                      } else {
                        var $newElements = $data.css({
                          opacity: 0,
                        });
                        $(
                          ".ta-row, .catsp-timeline-grid, .ta-collapse, .table-responsive tbody",
                          catsp_Wrapper_ID
                        ).append($newElements);
                        if (catspAccordion.length > 0) {
                          catspAccordion.accordion("refresh");
                          if (accordion_mode === "multi-open") {
                            catspAccordion
                              .find(".catsp-collapse-header")
                              .next()
                              .slideDown();
                            catspAccordion
                              .find(".catsp-collapse-header .fa")
                              .removeClass("fa-plus")
                              .addClass("fa-minus");
                          }
                        }
                        var $newElements = $data.css({
                          opacity: 1,
                        });
                      }
                      $(".page-numbers", catsp_Wrapper_ID).removeClass("active");
                      $(".page-numbers", catsp_Wrapper_ID).each(function () {
                        $(
                          ".catsp-post-pagination a[data-page=" + page + "]",
                          catsp_Wrapper_ID
                        ).addClass("active");
                      });
                      $(".catsp-infinite-scroll-loader", catsp_Wrapper_ID).remove();
                      if (Pagination_Type == "ajax_load_more") {
                        $(".catsp-load-more").show();
                      }
                      $(".catsp-load-more button").attr("catsp-processing", 0);
                      $(".ta-row div[class*=ta-col-]", catsp_Wrapper_ID)
                        .not(".catsp-added")
                        .addClass("animated catspFadeIn")
                        .one("webkitAnimationEnd animationEnd", function () {
                          $(this)
                            .removeClass("animated catspFadeIn")
                            .addClass("catsp-added");
                        });
                      if (totalPage == current_page) {
                        $(".catsp-load-more", catsp_Wrapper_ID)
                          .addClass("finished")
                          .removeClass("catsp-hide");
                        $(".catsp-load-more", catsp_Wrapper_ID)
                          .show()
                          .html(EndingMessage);
                      }
                      catsp_lazyload();
                    },
                  });
                } else {
                  $(".catsp-load-more", catsp_Wrapper_ID)
                    .addClass("finished")
                    .removeClass("catsp-hide");
                  $(".catsp-load-more", catsp_Wrapper_ID)
                    .show()
                    .html(EndingMessage);
                }
              });
            }
            if (Pagination_Type == "infinite_scroll") {
              var bufferBefore = Math.abs(20);
              $(window).scroll(function () {
                if (
                  $(
                    ".ta-row, .ta-collapse, .catsp-timeline-grid, .table-responsive tbody",
                    catsp_Wrapper_ID
                  ).length
                ) {
                  var TopAndContent =
                    $(
                      ".ta-row, .ta-collapse, .catsp-timeline-grid, .table-responsive tbody",
                      catsp_Wrapper_ID
                    ).offset().top +
                    $(
                      ".ta-row, .ta-collapse, .catsp-timeline-grid, .table-responsive tbody",
                      catsp_Wrapper_ID
                    ).outerHeight();
                  var areaLeft = TopAndContent - $(window).scrollTop();
                  if (areaLeft - bufferBefore < $(window).height()) {
                    if (
                      $(".catsp-load-more button", catsp_Wrapper_ID).attr(
                        "catsp-processing"
                      ) == 0
                    ) {
                      $(".catsp-load-more button", catsp_Wrapper_ID).trigger(
                        "click"
                      );
                    }
                  }
                }
              });
            }
          });
        }

        /* This code added for divi-builder ticker mode compatibility. */
        if (catspCarousel.length > 0 && catspCarouselData.mode == "ticker") {
          $(".ta-catsp-carousel img").removeAttr("loading");
          $(window).on("load", function () {
            $(".ta-catsp-carousel").each(function () {
              var thisdfd = $(this);
              var thisCSS = thisdfd.attr("style");
              $(this).removeAttr("style");
              setTimeout(function () {
                thisdfd.attr("style", thisCSS);
              }, 0);
            });
          });
        }

        /* Preloader js */
        $(document).ready(function () {
          $(".catsp-preloader", catsp_Wrapper_ID).css({
            backgroundImage: "none",
            visibility: "hidden",
          });
        });
        // This function added for catsp-Lazyload.
        function catsp_lazyload() {
          var $is_find = $(".catshowcase__item--thumbnail img").hasClass(
            "catsp-lazyload"
          );
          if ($is_find) {
            $("img.catsp-lazyload")
              .catsp_lazyload({ effect: "fadeIn", effectTime: 2000 })
              .removeClass("catsp-lazyload")
              .addClass("catsp-lazyloaded");
          }
          // catsp_item_same_height();
        }
        catsp_lazyload();
      });
    }
  };
  catsp_myScript();
});
