<?php

/**
 *  Carousel view
 *
 * @package    Catshowcase_pro
 * @subpackage Catshowcase_pro/public/template
 */
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

?>
<div id="catsp_wrapper-<?php echo esc_attr( $catsp_gl_id ); ?>" class="<?php self::catsp_wrapper_classes( $layout_preset, $catsp_gl_id, $grid_style, $item_same_height_class ); ?>" data-lang="<?php echo esc_attr( $spta_lang ); ?>">

	<?php
	CATSP_HTML::catsp_section_title( $section_title, $show_section_title );
	CATSP_HTML::catsp_preloader( $show_preloader );
	?>
	<div class="catshowcase">
		<div class="ta-row">
			<?php self::catsp_get_posts( $options, $layout_preset, $product_content_sorter, $catsp_query, $query_args, $catsp_gl_id ); ?>
		</div>
	</div>
</div>
