<?php

/**
 * Item Title
 *
 * This template can be overridden by copying it to yourtheme/catshowcase-pro/templates/item/title.php
 *
 * @package    Catshowcase_Pro
 * @subpackage Catshowcase_Pro/public
 */
$cats_baside_product_count   = $show_product_count && 'beside_cat' == $product_count_position ? $product_count_before . esc_html($product->count) . $product_count_after : '';
$cats_under_product_count   = $show_product_count && 'under_cat' == $product_count_position ? '<div class="catshowcase__item__count">' . $product_count_before . esc_html($product->count) . $product_count_after . '</div>' : '';

?>

<<?php echo esc_attr($product_category_tag); ?> class="catshowcase__item--title">

	<?php if ('none' === $catsp_page_link_type) { ?>
		<?php printf('<a %2$s>%1$s</a>', wp_kses(trim($catsp_product_category_name), $allowed_html_tags), esc_attr($catsp_link_rel_text)); ?>
	<?php } else { ?>
		<?php printf('<a href="%1$s" %3$s target="%4$s">%2$s %5$s</a>', esc_url(get_term_link($product->term_id)), wp_kses(trim($catsp_product_category_name), $allowed_html_tags), esc_attr($catsp_link_rel_text), esc_attr($catsp_link_target), esc_html($cats_baside_product_count)); ?>
	<?php } ?>

</<?php echo esc_attr($product_category_tag); ?>>
<?php
echo wp_kses_post($cats_under_product_count);