; (function ($) {
	'use strict'
  
	/**
	 * JavaScript code for admin dashboard.
	 *
	 */
  
	$(function () {
	  /* Preloader */
	  $("#ta_catsp_view_options .catsp-metabox").css("visibility", "hidden");
  
	  var CATSP_layout_type = $(
		'#catsp-section-ta_catsp_layouts_1 .catsp-field-layout_preset .catsp-siblings .catsp--sibling'
	  )
	  var CATSP_get_layout_value = $(
		'#catsp-section-ta_catsp_layouts_1 .catsp-field-layout_preset .catsp-siblings .catsp--sibling.catsp--active'
	  )
		.find('input')
		.val()
  
	  // Carousel Layout.
	  if (CATSP_get_layout_value !== 'carousel_layout') {
		$(
		  '#ta_catsp_view_options .catsp-nav ul li.menu-item_ta_catsp_view_options_3'
		).hide()
		$(
		  '#ta_catsp_view_options .catsp-nav ul li.menu-item_ta_catsp_view_options_1 a'
		).trigger('click');
	  } else {
		$(
		  '#ta_catsp_view_options .catsp-nav ul li.menu-item_ta_catsp_view_options_3'
		).show()
	  }
  
	  /**
	   * Show/Hide tabs on changing of layout.
	   */
	  $(CATSP_layout_type).on('change', 'input', function (event) {
		var CATSP_get_layout_value = $(this).val();
  
		// Carousel Layout.
		if (CATSP_get_layout_value !== 'carousel_layout') {
		  $(
			'#ta_catsp_view_options .catsp-nav ul li.menu-item_ta_catsp_view_options_3'
		  ).hide()
		  $(
			'#ta_catsp_view_options .catsp-nav ul li.menu-item_ta_catsp_view_options_1 a'
		  ).trigger('click');
		} else {
		  $(
			'#ta_catsp_view_options .catsp-nav ul li.menu-item_ta_catsp_view_options_3'
		  ).show()
		}
	  })
  
	  /* Preloader js */
	  $("#ta_catsp_view_options .catsp-metabox").css({ "backgroundImage": "none", "visibility": "visible", "minHeight": "auto" });
	  $("#ta_catsp_view_options .catsp-nav-metabox li").css("opacity", 1);
  
	  /* Copy to clipboard */
	  $('.catsp-shortcode-selectable').on('click',function (e) {
		e.preventDefault();
		catsp_copyToClipboard($(this));
		catsp_SelectText($(this));
		$(this).trigger("focus").select();
		$('.catsp-after-copy-text').animate({
		  opacity: 1,
		  bottom: 25
		}, 300);
		setTimeout(function () {
		  jQuery(".catsp-after-copy-text").animate({
			opacity: 0,
		  }, 200);
		  jQuery(".catsp-after-copy-text").animate({
			bottom: 0
		  }, 0);
		}, 2000);
	  });
	  $('.ta_catsp_input').on('click',function (e) {
		e.preventDefault();
		/* Get the text field */
		var copyText = $(this);
		/* Select the text field */
		copyText.select();
		document.execCommand("copy");
		$('.catsp-after-copy-text').animate({
		  opacity: 1,
		  bottom: 25
		}, 300);
		setTimeout(function () {
		  jQuery(".catsp-after-copy-text").animate({
			opacity: 0,
		  }, 200);
		  jQuery(".catsp-after-copy-text").animate({
			bottom: 0
		  }, 0);
		}, 2000);
	  });
	  function catsp_copyToClipboard(element) {
		var $temp = $("<input>");
		$("body").append($temp);
		$temp.val($(element).text()).select();
		document.execCommand("copy");
		$temp.remove();
	  }
	  function catsp_SelectText(element) {
		var r = document.createRange();
		var w = element.get(0);
		r.selectNodeContents(w);
		var sel = window.getSelection();
		sel.removeAllRanges();
		sel.addRange(r);
	  }
  
	})
  })(jQuery)
  