;(function( $, window ) {
  'use strict';

/*  Keep the accordion field's first item opened */
$(window).load(function () {
  $('.catsp-opened-accordion').each(function () {
    if (!$(this).hasClass('hidden')) {
      $(this).addClass('catsp_saved_filter')
    }
  })
})
$('.catsp-field-checkbox.catsp_advanced_filter').change(function (event) {
  $('.catsp-opened-accordion').each(function () {
    if ($(this).hasClass('hidden')) {
      $(this).removeClass('catsp_saved_filter')
    } else {
      $(this).addClass('catsp_saved_filter')
    }
    if (!$(this).hasClass('catsp_saved_filter')) {
      if (
        $(this)
          .find('.catsp-accordion-title')
          .siblings('.catsp-accordion-content')
          .hasClass('catsp-accordion-open')
      ) {
        $(this).find('.catsp-accordion-title')
      } else {
        $(this)
          .find('.catsp-accordion-title')
          .trigger('click')
        $(this)
          .find('.catsp-accordion-content')
          .find('.catsp-cloneable-add')
          .trigger('click')
      }
    }
  })
})

})( jQuery, window, document );