<?php

/**
 * Button
 *
 * This template can be overridden by copying it to yourtheme/catshowcase-pro/templates/item/button.php
 *
 * @package    Catshowcase_pro_Pro
 * @subpackage Catshowcase_pro_Pro/public
 */

if ('text_link' === $button_type) {
?>

	<?php if ('none' === $catsp_page_link_type) { ?>
		<a class="catshowcase__item__btn" target="<?php echo esc_attr($readmore_target); ?>" <?php echo esc_html($catsp_link_rel_text); ?>>
		<?php } else { ?>
			<a class="catshowcase__item__btn" target="<?php echo esc_attr($readmore_target); ?>" ta rel="<?php echo esc_attr($catsp_link_rel); ?>" href="<?php echo esc_url(get_term_link($product->term_id)); ?>" <?php echo esc_html($catsp_link_rel_text); ?>>
			<?php } ?>

			<?php echo esc_html($catsp_read_label); ?> </a>

		<?php
	} else {
		?>
			<div class="catshowcase__item__button">
				<?php if ('none' === $catsp_page_link_type) { ?>
					<a class="catshowcase__item__btn" target="<?php echo esc_attr($readmore_target); ?>" <?php echo esc_html($catsp_link_rel_text); ?>>
					<?php } else { ?>
						<a class="catshowcase__item__btn" target="<?php echo esc_attr($readmore_target); ?>" href="<?php echo esc_url(get_term_link($product->term_id)); ?>" <?php echo esc_html($catsp_link_rel_text); ?>>
						<?php } ?>
						<?php echo esc_html($catsp_read_label); ?> </a>
			</div>
		<?php
	}
