<?php

/**
 * Category Icon
 *
 * This template can be overridden by copying it to yourtheme/catshowcase-pro/templates/item/icon.php
 *
 * @package    Catshowcase_Pro
 * @subpackage Catshowcase_Pro/public
 */

$meta = get_term_meta($product->term_id, 'ta_cat_metabox', true);
$product_cat_icon = isset($meta['product_cat_icon']) ? $meta['product_cat_icon'] : '';

?>
<div class="catshowcase__item__icon">
	<?php
	if ($show_category_icon) {
		echo wp_kses_post("<i class='{$product_cat_icon}'></i>");
	}
	?>
</div>